#include "1.3.h"

#include "main_utils.h"
#include <ctime>

int main() {
  int test = 0;
  CHECK_EQ(GetKth(vector<int>{4, 7, 5, 3, 10, 6, 4, 2, 8, 11}, 2), 8);
  cout << "Test #" << test++ << " PASSED" << endl;

  CHECK_EQ(GetKth(vector<int>{4, 7, 5, 3, 10, 6, 4, 2, 8, 11}, 5), 2);
  cout << "Test #" << test++ << " PASSED" << endl;

  CHECK_EQ(GetKth(vector<double>{7.0, 4.0, 5.0, 3.0, 10.0, 6.0, 4.0, 3.0, 8.0, 10.1}, 0), 9);
  cout << "Test #" << test++ << " PASSED" << endl;

  CHECK_EQ(GetKth(vector<double>{7.0, 4.1, 5.0, 3.0, 10.0, 6.0, 4.2, 3.0, 8.0, 10.1}, 6), 6);
  cout << "Test #" << test++ << " PASSED" << endl;

  CHECK_EQ(GetKth(vector<double>{7.0, 4.1, 5.0, 3.0, 10.0, 6.0, 4.2, 3.0, 8.0, 10.1}, 3), 0);
  cout << "Test #" << test++ << " PASSED" << endl;

  CHECK_EQ(GetKth(vector<double>{7.0, 4.0, 5.0, 3.0, 10.0, 6.0, 4.0, 3.1, 8.0, 10.1}, 9), 3);
  cout << "Test #" << test++ << " PASSED" << endl;

  // Huge vector, for the performance test.
  cout << "Preparing performance test..." << endl;
  vector<char> big_v;
  const int N = 1000000000;
  big_v.reserve(N);
  for (int i = 0; i < N; ++i) {
    big_v.push_back(i * 1000000007);
  }
  cout << "Running test..." << endl;
  clock_t c0 = clock();
  const int pos = GetKth(big_v, 34);
  clock_t c1 = clock();
  CHECK_EQ(int(big_v[pos]), 127);
  cout << "Done! Time: " << double(c1 - c0) / CLOCKS_PER_SEC << " seconds."
       << endl;
}
